# Multisignature wallet

## Generating keypair

First of all you need a public/private keys. To generate it run shell command:

`fift -s generate-keypair.fif wallet`

This script will generate wallet.pk file which contains your private key. In the shell you can also see a public key integer representation associtated with new private key.

To obtain public key from generated *.pk file, you can run `get-pubkey.fif` script:

`fift -s get-pubkey.fif wallet.pk`

## Creating multisig weallet

You can create multisignature wallet with fift script *`multisig-wallet.fif`*. Run shell command:

`fift -s multisig-wallet.fif -1 mywallet 1 1`

This command creates wallet with one owner. If you want create wallet with several owners, you should get public keys of another owners. 

To create wallet with several owners you should additionaly pass int representations of public keys. For example:
`fift -s multisig-wallet.fif -1 mywallet 3 2 0000000000000 112323231231`

*usage: `fift -s multisig-wallet.fif <workchain-id> <filename-base> <n> <k> [<public_key_1> <public_key_2> ... <public_key_[n-1]>]`*

3 - is parameter "n" that represents number of owner. Note that you must pass n-1 additional public keys because first one will be automatically generated or restored from createt or loaded *.pk file ('mywallet' in example above).
2 - parameter "k". k must be lower or equal than n. It represents required number of signatures to send message from wallet.

To see usage info, execute `fift -d multisig-wallet.fif` without arguments.

After creating wallet, you should send generated *.addr file to another owners. They must rename it to their *.pk file base name. For example if you have w0.pk then you should rename *.addr file to w0.addr

## Creating order

To create order you should run create-order.fif script. 

`fift -s create-order.fif wallets/msig Ef8RS0T6tttnh69sMD0MB1rn1GOUcavBtjrm5wuJMZXVB5CX 1 600 0.66`

*usage: `fift -s create-order.fif <filename-base> <dest-addr> <seqno> <valid-for> <amount> [-B <body-boc>] [<savefile>]`*

First argument is filename base for pk and addr files. 

`Ef8RS0T6tttnh69sMD0MB1rn1GOUcavBtjrm5wuJMZXVB5CX` - destination address

`1` - seqno (first 8 digits in data section of the wallet)

`600` - time in seconds during which the order will be stored in wallet data.

`0.66` - amount of Grams that will be sent to destination address.

To send created message use sendfile command in lite-client. By default created file has name wallet-query.boc. Alternatively, you can add new signatures to create `wallet-query.boc` and after that a message.

### Signing created order

Another owner can be sign created order(but not sent via lite-client) with the help of script `sign-new-order.fif`

`fift -s sign-new-order.fif wallet-query.boc mykey.pk`

This command will sign message stored in wallet-query.boc with you private key stored in mykey.pk.

### Signing pending order stored in wallet data

To sign already sent order you should run this command:

`fift -s sign-pending-order <filename-base> <seqno> <order-id>`

Then send created wallet-query.boc via sendfile command in lite-client. This will add you signature to message stored in data in wallet. This script requires `<filename-base>.addr` file.

## Get Methods

### all_orders_list

Requires no args. The result of this method is list of orders. Each is represented by `<order-id> <order-slice> <num-of-signers>`. For example:

*`[ 1 C{80D6E1972D4499171C9FDFC16A520C06AFB3661190C218E2CB1F798B3DA227E4} 1 ]`*

### get_order_info <order_id>

Requires order id as argument. Returns information about order with format : `<workchain> <address(int)> <bounce> <nanograms> <valid-until> <body> <list-of-signers>`

For example:

`[ -1 7822308005440038650668100458699255272943444705737581530762634522772314117383 -1 1000000000 1571170810 CS{Cell{007c627f88a5a27cd4ed73c3d7a9181e8603acd3ea31ca3ed5e0db1d737385c498caea83a1dcd650000000000000000000000000000000000000544553547632} bits: 416..496; refs: 0..0} [ [ 101495306622484493711607859331024283480312845400728332844370802528508977182824 ] (null) ] ]  `

### get_signed_by <public_key(int)>

Returns a list of order-ids of orders that are signed by owner associated with given public key.

### get_not_signed_by <public_key(int)>

Returns a list of orders-ids of orders that are **not** signed by owner associated with given public key.

### get_seqno

Returns current wallet seqno.